Index: src/main/java/com/xpn/xwiki/web/Utils.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/Utils.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/Utils.java	(working copy)
@@ -25,6 +25,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.plugin.fileupload.FileUploadPlugin;
 import com.xpn.xwiki.xmlrpc.XWikiXMLRPCRequest;
 import org.apache.commons.fileupload.FileItem;
@@ -58,9 +59,9 @@
             response.setContentType("text/html; charset=" + context.getWiki().getEncoding());
         }
 
-        String action = context.getAction();
-        if ((!"download".equals(action))
-                && (!"skin".equals(action))) {
+        DocumentAction action = context.getAction();
+        if ((!DocumentAction.DOWNLOAD.equals(action))
+                && (!DocumentAction.SKIN.equals(action))) {
             if (context.getResponse() instanceof XWikiServletResponse) {
                 // Add a last modified to tell when the page was last updated
                 if (context.getWiki().getXWikiPreferenceAsLong("headers_lastmodified", 0, context) != 0) {
@@ -82,8 +83,8 @@
             }
         }
 
-        if (("download".equals(action))
-                || ("skin".equals(action))) {
+        if ((DocumentAction.DOWNLOAD.equals(action))
+                || (DocumentAction.SKIN.equals(action))) {
             // Set a nocache to make sure these files are not cached by proxies
             if (context.getWiki().getXWikiPreferenceAsLong("headers_nocache", 1, context) != 0) {
                 response.setHeader("Cache-Control", "no-cache");
@@ -136,7 +137,7 @@
         return redirect;
     }
 
-    public static String getRedirect(String action, XWikiContext context) {
+    public static String getRedirect(DocumentAction action, XWikiContext context) {
         String redirect;
         redirect = context.getRequest().getParameter("xredirect");
         if ((redirect == null) || (redirect.equals("")))
@@ -194,8 +195,19 @@
         }
         return data;
     }
+    
+    /**
+     * @see Utils#prepareContext(DocumentAction, XWikiRequest, XWikiResponse, XWikiEngineContext)
+     * @deprecated use
+     *             {@link Utils#prepareContext(DocumentAction, XWikiRequest, XWikiResponse, XWikiEngineContext)}
+     */
+    public static XWikiContext prepareContext(String action, XWikiRequest request, XWikiResponse response,
+        XWikiEngineContext engine_context) throws XWikiException {
+        DocumentAction documentAction = DocumentAction.valueOf(action);
+        return Utils.prepareContext(documentAction, request, response, engine_context);
+    }
 
-    public static XWikiContext prepareContext(String action, XWikiRequest request, XWikiResponse response,
+    public static XWikiContext prepareContext(DocumentAction action, XWikiRequest request, XWikiResponse response,
                                               XWikiEngineContext engine_context) throws XWikiException {
         // Test works with xwiki-test.cfg instead of xwiki.cfg
         XWikiContext context = new XWikiContext();
Index: src/main/java/com/xpn/xwiki/web/XWikiDefaultURLFactory.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/XWikiDefaultURLFactory.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/XWikiDefaultURLFactory.java	(working copy)
@@ -22,23 +22,24 @@
 package com.xpn.xwiki.web;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 
 import java.net.URL;
 
 public abstract class XWikiDefaultURLFactory implements XWikiURLFactory {
     public URL createURL(String web, String name, XWikiContext context) {
-        return createURL(web, name, "view", null, null, context);
+        return createURL(web, name, DocumentAction.VIEW, null, null, context);
     }
 
-    public URL createExternalURL(String web, String name, String action, String querystring, String anchor, XWikiContext context) {
+    public URL createExternalURL(String web, String name, DocumentAction action, String querystring, String anchor, XWikiContext context) {
         return createExternalURL(web, name, action, querystring, anchor, context.getDatabase(), context);
     }
 
-    public URL createURL(String web, String name, String action, XWikiContext context) {
+    public URL createURL(String web, String name, DocumentAction action, XWikiContext context) {
         return createURL(web, name, action, null, null, context);
     }
 
-    public URL createURL(String web, String name, String action, String querystring, String anchor, XWikiContext context) {
+    public URL createURL(String web, String name, DocumentAction action, String querystring, String anchor, XWikiContext context) {
         return createURL(web, name, action, querystring, anchor, context.getDatabase(), context);
     }
 
@@ -46,7 +47,7 @@
         return createSkinURL(filename, web, name, context.getDatabase(), context);
     }
 
-    public URL createAttachmentURL(String filename, String web, String name, String action, String querystring, XWikiContext context) {
+    public URL createAttachmentURL(String filename, String web, String name, DocumentAction action, String querystring, XWikiContext context) {
         return createAttachmentURL(filename, web, name, action, querystring, context.getDatabase(), context);
     }
 
Index: src/main/java/com/xpn/xwiki/web/AdminAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/AdminAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/AdminAction.java	(working copy)
@@ -23,7 +23,6 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
-import com.xpn.xwiki.api.Document;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.doc.XWikiLock;
 import org.apache.commons.logging.Log;
Index: src/main/java/com/xpn/xwiki/web/XWikiAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/XWikiAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/XWikiAction.java	(working copy)
@@ -25,6 +25,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.monitor.api.MonitorPlugin;
 import com.xpn.xwiki.plugin.fileupload.FileUploadPlugin;
@@ -75,7 +76,8 @@
                                  HttpServletRequest req,
                                  HttpServletResponse resp)
             throws Exception, ServletException {
-        String action = mapping.getName();
+        
+        DocumentAction action = DocumentAction.valueOf(mapping.getName());
 
         MonitorPlugin monitor = null;
         FileUploadPlugin fileupload = null;
@@ -84,7 +86,7 @@
         try {
             XWikiRequest request = new XWikiServletRequest(req);
             XWikiResponse response = new XWikiServletResponse(resp);
-            context = Utils.prepareContext(mapping.getName(), request, response,
+            context = Utils.prepareContext(action, request, response,
                     new XWikiServletContext(servlet.getServletContext()));
 
             // Add the form to the context
@@ -119,7 +121,7 @@
             // Start monitoring timer
             monitor = (MonitorPlugin) xwiki.getPlugin("monitor", context);
             if (monitor != null)
-                monitor.startRequest("", mapping.getName(), context.getURL());
+                monitor.startRequest("", action, context.getURL());
             if (monitor != null)
                 monitor.startTimer("request");
 
@@ -134,7 +136,7 @@
 
                 // Let's handle the notification and make sure it never fails
                 try {
-                    xwiki.getNotificationManager().preverify(context.getDoc(), mapping.getName(), context);
+                    xwiki.getNotificationManager().preverify(context.getDoc(), action, context);
                 }
                 catch (Throwable e) {
                     e.printStackTrace();
@@ -149,7 +151,8 @@
                 }
 
                 if (renderResult != null) {
-                    if ((doc.isNew() && ("view".equals(action) || "delete".equals(action)))) {
+                    if ((doc.isNew() && (DocumentAction.VIEW.equals(action) 
+                        || DocumentAction.DELETE.equals(action)))) {
                         String page = Utils.getPage(request, "docdoesnotexist");
                         Utils.parseTemplate(page, context);
                     } else {
@@ -160,8 +163,8 @@
                 return null;
             } catch (Throwable e) {
                 if (!(e instanceof XWikiException)) {
-                   e = new XWikiException(XWikiException.MODULE_XWIKI_APP, XWikiException.ERROR_XWIKI_UNKNOWN,
-                            "Uncaught exception", e);
+                   e = new XWikiException(XWikiException.MODULE_XWIKI_APP, 
+                                          XWikiException.ERROR_XWIKI_UNKNOWN, "Uncaught exception", e);
                 }
 
                 try {
@@ -207,7 +210,7 @@
 
                 // Let's handle the notification and make sure it never fails
                 try {
-                    xwiki.getNotificationManager().verify(context.getDoc(), mapping.getName(), context);
+                    xwiki.getNotificationManager().verify(context.getDoc(), action, context);
                 } catch (Throwable e) {
                     e.printStackTrace();
                     }
Index: src/main/java/com/xpn/xwiki/web/XWikiURLFactory.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/XWikiURLFactory.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/XWikiURLFactory.java	(working copy)
@@ -22,27 +22,28 @@
 package com.xpn.xwiki.web;
 
 import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.api.DocumentAction;
 
 import java.net.URL;
 
 public interface XWikiURLFactory {
     public void init(XWikiContext context);
     public URL createURL(String web, String name, XWikiContext context);
-    public URL createURL(String web, String name, String action, XWikiContext context);
-    public URL createURL(String web, String name, String action, boolean redirect, XWikiContext context);
-    public URL createURL(String web, String name, String action, String querystring, String anchor,
+    public URL createURL(String web, String name, DocumentAction action, XWikiContext context);
+    public URL createURL(String web, String name, DocumentAction action, boolean redirect, XWikiContext context);
+    public URL createURL(String web, String name, DocumentAction action, String querystring, String anchor,
                          XWikiContext context);
-    public URL createExternalURL(String web, String name, String action, String querystring, String anchor,
+    public URL createExternalURL(String web, String name, DocumentAction action, String querystring, String anchor,
                          XWikiContext context);
-    public URL createURL(String web, String name, String action, String querystring, String anchor,
+    public URL createURL(String web, String name, DocumentAction action, String querystring, String anchor,
                          String xwikidb, XWikiContext context);
-    public URL createExternalURL(String web, String name, String action, String querystring, String anchor,
+    public URL createExternalURL(String web, String name, DocumentAction action, String querystring, String anchor,
                          String xwikidb, XWikiContext context);
     public URL createSkinURL(String filename, String skin, XWikiContext context);
     public URL createSkinURL(String filename, String web, String name, XWikiContext context);
     public URL createSkinURL(String filename, String web, String name, String xwikidb, XWikiContext context);
-    public URL createAttachmentURL(String filename, String web, String name, String action, String querystring, XWikiContext context);
-    public URL createAttachmentURL(String filename, String web, String name, String action, String querystring, String xwikidb, XWikiContext context);
+    public URL createAttachmentURL(String filename, String web, String name, DocumentAction action, String querystring, XWikiContext context);
+    public URL createAttachmentURL(String filename, String web, String name, DocumentAction action, String querystring, String xwikidb, XWikiContext context);
     public URL createAttachmentRevisionURL(String filename, String web, String name, String revision, String querystring, XWikiContext context);
     public URL createAttachmentRevisionURL(String filename, String web, String name, String revision, String querystring, String xwikidb, XWikiContext context);
     public URL getRequestURL(XWikiContext context);
Index: src/main/java/com/xpn/xwiki/web/LogoutAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/LogoutAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/LogoutAction.java	(working copy)
@@ -18,21 +18,26 @@
  * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
  *
  */
-package com.xpn.xwiki.web;
-
-import com.xpn.xwiki.XWikiContext;
-import com.xpn.xwiki.XWikiException;
-
-public class LogoutAction extends XWikiAction {
-	public boolean action(XWikiContext context) throws XWikiException {
-        XWikiRequest request = context.getRequest();
-        XWikiResponse response = context.getResponse();
-
-        String redirect;
-        redirect = context.getRequest().getParameter("xredirect");
-        if ((redirect == null)||(redirect.equals("")))
-            redirect = context.getURLFactory().createURL("Main", "WebHome", "view", context).toString();
-        sendRedirect(response, redirect);
-        return false;
-	}
-}
+package com.xpn.xwiki.web;
+
+import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
+
+public class LogoutAction extends XWikiAction
+{
+    public boolean action(XWikiContext context) throws XWikiException
+    {
+        XWikiRequest request = context.getRequest();
+        XWikiResponse response = context.getResponse();
+
+        String redirect;
+        redirect = context.getRequest().getParameter("xredirect");
+        if ((redirect == null) || (redirect.equals("")))
+            redirect =
+                context.getURLFactory()
+                    .createURL("Main", "WebHome", DocumentAction.VIEW, context).toString();
+        sendRedirect(response, redirect);
+        return false;
+    }
+}
Index: src/main/java/com/xpn/xwiki/web/CommentAddAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/CommentAddAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/CommentAddAction.java	(working copy)
@@ -23,6 +23,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
 import com.xpn.xwiki.objects.classes.BaseClass;
@@ -60,10 +61,10 @@
                 xwiki.saveDocument(doc, olddoc, context.getMessageTool().get("core.comment.addComment"), context);
             }
             // forward to edit
-            String redirect = Utils.getRedirect("edit", context);
+            String redirect = Utils.getRedirect(DocumentAction.EDIT, context);
             sendRedirect(response, redirect);
         } else {
-                String url = context.getDoc().getURL("view", "xpage=comments&confirm=false",context);
+                String url = context.getDoc().getURL(DocumentAction.VIEW, "xpage=comments&confirm=false",context);
             try {
                 response.sendRedirect(url);
             } catch (Exception e) {
Index: src/main/java/com/xpn/xwiki/web/XWikiServletURLFactory.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/XWikiServletURLFactory.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/XWikiServletURLFactory.java	(working copy)
@@ -24,6 +24,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import org.apache.commons.logging.Log;
@@ -139,17 +140,17 @@
         }
     }
 
-    public URL createURL(String web, String name, String action, boolean redirect,
+    public URL createURL(String web, String name, DocumentAction action, boolean redirect,
         XWikiContext context)
     {
         return createURL(web, name, action, context);
     }
 
-    public URL createURL(String web, String name, String action, String querystring,
+    public URL createURL(String web, String name, DocumentAction action, String querystring,
         String anchor, String xwikidb, XWikiContext context)
     {
         // Action and Query String transformers
-        if (("view".equals(action)) && (context.getLinksAction() != null)) {
+        if ((DocumentAction.VIEW.equals(action)) && (context.getLinksAction() != null)) {
             action = context.getLinksAction();
         }
         if (context.getLinksQueryString() != null) {
@@ -185,21 +186,22 @@
         }
     }
 
-    private void addAction(StringBuffer newpath, String action, XWikiContext context)
+    private void addAction(StringBuffer newpath, DocumentAction action, XWikiContext context)
     {
         boolean showViewAction = context.getWiki().showViewAction(context);
-        if ((!"view".equals(action) || (showViewAction))) {
-            newpath.append(action);
+        if ((!DocumentAction.VIEW.equals(action) || (showViewAction))) {
+            newpath.append(action.toString());
             newpath.append("/");
         }
     }
 
-    private void addSpace(StringBuffer newpath, String web, String action, XWikiContext context)
+    private void addSpace(StringBuffer newpath, String web, DocumentAction action,
+        XWikiContext context)
     {
         boolean useDefaultWeb = context.getWiki().useDefaultWeb(context);
         if (useDefaultWeb) {
             String defaultWeb = context.getWiki().getDefaultWeb(context);
-            useDefaultWeb = (web.equals(defaultWeb)) && ("view".equals(action));
+            useDefaultWeb = (web.equals(defaultWeb)) && (DocumentAction.VIEW.equals(action));
         }
         if (!useDefaultWeb) {
             newpath.append(encode(web, context));
@@ -207,11 +209,13 @@
         }
     }
 
-    private void addName(StringBuffer newpath, String name, String action, XWikiContext context)
+    private void addName(StringBuffer newpath, String name, DocumentAction action,
+        XWikiContext context)
     {
         XWiki xwiki = context.getWiki();
         if ((xwiki.useDefaultAction(context))
-            || (!name.equals(xwiki.getDefaultPage(context)) || (!"view".equals(action)))) {
+            || (!name.equals(xwiki.getDefaultPage(context)) || (!DocumentAction.VIEW
+                .equals(action)))) {
             newpath.append(encode(name, context));
         }
     }
@@ -236,8 +240,8 @@
         return Utils.encode(name, context);
     }
 
-    public URL createExternalURL(String web, String name, String action, String querystring,
-        String anchor, String xwikidb, XWikiContext context)
+    public URL createExternalURL(String web, String name, DocumentAction action,
+        String querystring, String anchor, String xwikidb, XWikiContext context)
     {
         return this.createURL(web, name, action, querystring, anchor, xwikidb, context);
     }
@@ -261,9 +265,9 @@
     {
         StringBuffer newpath = new StringBuffer(servletPath);
         newpath.append(actionPath);
-        addAction(newpath, "skin", context);
-        addSpace(newpath, web, "skin", context);
-        addName(newpath, name, "skin", context);
+        addAction(newpath, DocumentAction.SKIN, context);
+        addSpace(newpath, web, DocumentAction.SKIN, context);
+        addName(newpath, name, DocumentAction.SKIN, context);
         addFileName(newpath, filename, false, context);
         try {
             return new URL(getServerURL(xwikidb, context), newpath.toString());
@@ -286,8 +290,8 @@
         }
     }
 
-    public URL createAttachmentURL(String filename, String web, String name, String action,
-        String querystring, String xwikidb, XWikiContext context)
+    public URL createAttachmentURL(String filename, String web, String name,
+        DocumentAction action, String querystring, String xwikidb, XWikiContext context)
     {
         StringBuffer newpath = new StringBuffer(servletPath);
         newpath.append(actionPath);
@@ -305,7 +309,7 @@
             newpath.append(querystring);
         }
 
-        if ((context != null) && "viewrev".equals(context.getAction())) {
+        if ((context != null) && DocumentAction.VIEWREV.equals(context.getAction())) {
             revdoc = context.get("rev").toString();
             Log log = LogFactory.getLog(XWikiServletURLFactory.class);
             try {
@@ -344,7 +348,7 @@
     public URL createAttachmentRevisionURL(String filename, String web, String name,
         String revision, String querystring, String xwikidb, XWikiContext context)
     {
-        String action = "downloadrev";
+        DocumentAction action = DocumentAction.DOWNLOADREV;
         StringBuffer newpath = new StringBuffer(servletPath);
         newpath.append(actionPath);
         addAction(newpath, action, context);
Index: src/main/java/com/xpn/xwiki/web/UploadAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/UploadAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/UploadAction.java	(working copy)
@@ -29,6 +29,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiAttachment;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.plugin.fileupload.FileUploadPlugin;
@@ -129,7 +130,7 @@
         // forward to attach page
         String redirect = fileupload.getFileItemAsString("xredirect", context);
         if ((redirect == null) || (redirect.equals("")))
-            redirect = context.getDoc().getURL("attach", true, context);
+            redirect = context.getDoc().getURL(DocumentAction.ATTACH, true, context);
         sendRedirect(response, redirect);
         return false;
     }
Index: src/main/java/com/xpn/xwiki/web/ObjectRemoveAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/ObjectRemoveAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/ObjectRemoveAction.java	(working copy)
@@ -23,6 +23,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.objects.BaseObject;
 
@@ -48,7 +49,7 @@
         xwiki.saveDocument(doc, olddoc, context.getMessageTool().get("core.comment.deleteObject"), context);
 
         // forward to edit
-        String redirect = Utils.getRedirect("edit", context);
+        String redirect = Utils.getRedirect(DocumentAction.EDIT, context);
         sendRedirect(response, redirect);
         return false;
 	}
Index: src/main/java/com/xpn/xwiki/web/EditAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/EditAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/EditAction.java	(working copy)
@@ -23,7 +23,6 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
-import com.xpn.xwiki.api.Document;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.doc.XWikiLock;
 import com.xpn.xwiki.plugin.captcha.CaptchaPluginApi;
Index: src/main/java/com/xpn/xwiki/web/RollbackAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/RollbackAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/RollbackAction.java	(working copy)
@@ -23,6 +23,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 import java.util.List;
@@ -70,7 +71,7 @@
         xwiki.saveDocument(newdoc, olddoc, context.getMessageTool().get("core.comment.rollback", params), context);
 
         // forward to view
-        String redirect = Utils.getRedirect("view", context);
+        String redirect = Utils.getRedirect(DocumentAction.VIEW, context);
         sendRedirect(response, redirect);
         return false;
 	}
Index: src/main/java/com/xpn/xwiki/web/SaveAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/SaveAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/SaveAction.java	(working copy)
@@ -23,6 +23,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.doc.XWikiLock;
 import com.xpn.xwiki.plugin.captcha.CaptchaPluginApi;
@@ -124,7 +125,7 @@
 			return true;
 		}
 		// forward to view
-		sendRedirect(context.getResponse(), Utils.getRedirect("view", context));
+		sendRedirect(context.getResponse(), Utils.getRedirect(DocumentAction.VIEW, context));
 		return false;
 	}
 
Index: src/main/java/com/xpn/xwiki/web/XWikiMessageTool.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/XWikiMessageTool.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/XWikiMessageTool.java	(working copy)
@@ -41,6 +41,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.AccessLevel;
 import com.xpn.xwiki.doc.XWikiDocument;
 
 /**
@@ -269,7 +270,7 @@
         Properties props = null;
         try {
             XWikiDocument docBundle = context.getWiki().getDocument(documentName, context);
-            if (context.getWiki().getRightService().hasAccessLevel("view", context.getUser(),
+            if (context.getWiki().getRightService().hasAccessLevel(AccessLevel.VIEW, context.getUser(),
                 documentName, context) && !docBundle.isNew())
             {
                 props = getDocumentBundleProperties(docBundle);
Index: src/main/java/com/xpn/xwiki/web/RedirectAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/RedirectAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/RedirectAction.java	(working copy)
@@ -22,6 +22,7 @@
 
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 
 public class RedirectAction extends XWikiAction {
 	public boolean action(XWikiContext context) throws XWikiException {
@@ -31,7 +32,7 @@
         String redirect;
         redirect = context.getRequest().getParameter("xredirect");
         if ((redirect == null)||(redirect.equals("")))
-            redirect = context.getURLFactory().createURL("Main", "WebHome", "view", context).toString();
+            redirect = context.getURLFactory().createURL("Main", "WebHome", DocumentAction.VIEW, context).toString();
         sendRedirect(response, redirect);
         return false;
 	}
Index: src/main/java/com/xpn/xwiki/web/ViewAction.java
===================================================================
--- src/main/java/com/xpn/xwiki/web/ViewAction.java	(revision 3976)
+++ src/main/java/com/xpn/xwiki/web/ViewAction.java	(working copy)
@@ -22,6 +22,7 @@
 import com.xpn.xwiki.XWiki;
 import com.xpn.xwiki.XWikiContext;
 import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.api.DocumentAction;
 import com.xpn.xwiki.doc.XWikiDocument;
 import com.xpn.xwiki.plugin.captcha.CaptchaPluginApi;
 import org.apache.velocity.VelocityContext;
@@ -56,7 +57,7 @@
         // view a specific revision of a document).
         String rev = request.getParameter("rev");
         if (rev != null) {
-            String url = context.getDoc().getURL("viewrev", request.getQueryString(), context);
+            String url = context.getDoc().getURL(DocumentAction.VIEWREV, request.getQueryString(), context);
             try {
                 context.getResponse().sendRedirect(url);
             } catch (IOException e) {
